<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>PathUtils.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.common</a> &gt; <span class="el_source">PathUtils.java</span></div><h1>PathUtils.java</h1><pre class="source lang-java linenums"> /**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.common;


/**
 * Path related utilities
 */    
<span class="nc" id="L25">public class PathUtils {</span>
	
	/** validate the provided znode path string
	 * @param path znode path string
	 * @param isSequential if the path is being created
	 * with a sequential flag
	 * @throws IllegalArgumentException if the path is invalid
	 */
	public static void validatePath(String path, boolean isSequential) 
		throws IllegalArgumentException {
<span class="fc bfc" id="L35" title="All 2 branches covered.">		validatePath(isSequential? path + &quot;1&quot;: path);</span>
<span class="fc" id="L36">	}</span>
	
    /**
     * Validate the provided znode path string
     * @param path znode path string
     * @throws IllegalArgumentException if the path is invalid
     */
    public static void validatePath(String path) throws IllegalArgumentException {
<span class="fc bfc" id="L44" title="All 2 branches covered.">        if (path == null) {</span>
<span class="fc" id="L45">            throw new IllegalArgumentException(&quot;Path cannot be null&quot;);</span>
        }
<span class="fc bfc" id="L47" title="All 2 branches covered.">        if (path.length() == 0) {</span>
<span class="fc" id="L48">            throw new IllegalArgumentException(&quot;Path length must be &gt; 0&quot;);</span>
        }
<span class="fc bfc" id="L50" title="All 2 branches covered.">        if (path.charAt(0) != '/') {</span>
<span class="fc" id="L51">            throw new IllegalArgumentException(</span>
                         &quot;Path must start with / character&quot;);
        }
<span class="fc bfc" id="L54" title="All 2 branches covered.">        if (path.length() == 1) { // done checking - it's the root</span>
<span class="fc" id="L55">            return;</span>
        }
<span class="fc bfc" id="L57" title="All 2 branches covered.">        if (path.charAt(path.length() - 1) == '/') {</span>
<span class="fc" id="L58">            throw new IllegalArgumentException(</span>
                         &quot;Path must not end with / character&quot;);
        }

<span class="fc" id="L62">        String reason = null;</span>
<span class="fc" id="L63">        char lastc = '/';</span>
<span class="fc" id="L64">        char chars[] = path.toCharArray();</span>
        char c;
<span class="fc bfc" id="L66" title="All 2 branches covered.">        for (int i = 1; i &lt; chars.length; lastc = chars[i], i++) {</span>
<span class="fc" id="L67">            c = chars[i];</span>

<span class="pc bpc" id="L69" title="1 of 2 branches missed.">            if (c == 0) {</span>
<span class="nc" id="L70">                reason = &quot;null character not allowed @&quot; + i;</span>
<span class="nc" id="L71">                break;</span>
<span class="fc bfc" id="L72" title="All 4 branches covered.">            } else if (c == '/' &amp;&amp; lastc == '/') {</span>
<span class="fc" id="L73">                reason = &quot;empty node name specified @&quot; + i;</span>
<span class="fc" id="L74">                break;</span>
<span class="fc bfc" id="L75" title="All 4 branches covered.">            } else if (c == '.' &amp;&amp; lastc == '.') {</span>
<span class="fc bfc" id="L76" title="All 6 branches covered.">                if (chars[i-2] == '/' &amp;&amp;</span>
                        ((i + 1 == chars.length)
                                || chars[i+1] == '/')) {
<span class="fc" id="L79">                    reason = &quot;relative paths not allowed @&quot; + i;</span>
<span class="fc" id="L80">                    break;</span>
                }
<span class="fc bfc" id="L82" title="All 2 branches covered.">            } else if (c == '.') {</span>
<span class="fc bfc" id="L83" title="All 6 branches covered.">                if (chars[i-1] == '/' &amp;&amp;</span>
                        ((i + 1 == chars.length)
                                || chars[i+1] == '/')) {
<span class="fc" id="L86">                    reason = &quot;relative paths not allowed @&quot; + i;</span>
<span class="fc" id="L87">                    break;</span>
                }
<span class="pc bpc" id="L89" title="10 of 16 branches missed.">            } else if (c &gt; '\u0000' &amp;&amp; c &lt; '\u001f'</span>
                    || c &gt; '\u007f' &amp;&amp; c &lt; '\u009F'
                    || c &gt; '\ud800' &amp;&amp; c &lt; '\uf8ff'
                    || c &gt; '\ufff0' &amp;&amp; c &lt; '\uffff') {
<span class="fc" id="L93">                reason = &quot;invalid charater @&quot; + i;</span>
<span class="fc" id="L94">                break;</span>
            }
        }

<span class="fc bfc" id="L98" title="All 2 branches covered.">        if (reason != null) {</span>
<span class="fc" id="L99">            throw new IllegalArgumentException(</span>
                    &quot;Invalid path string \&quot;&quot; + path + &quot;\&quot; caused by &quot; + reason);
        }
<span class="fc" id="L102">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>